
using UnityEngine;

public class ArmorBehaviour : MonoBehaviour
  {
    private bool equipped;
    public string armorPiece;
    public int armorTier;
    public float stabResistance;
    private bool blockingStab;
    public string otherSprite;
    public string otherName;
    public string otherPiece;
    public float otherResist;
    public float mass;
    public int otherTier;
    public bool threepieces;
    public string thirdsprite;
    public string thirdpart;

    private void Start()
    {
      this.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[0];
      switch (this.armorTier)
      {
        case 0:
          this.GetComponent<PhysicalProperties>().Softness = 1f;
          this.GetComponent<PhysicalProperties>().Brittleness = 1f;
          break;
        case 1:
          this.GetComponent<PhysicalProperties>().Softness = 0.15f;
          this.GetComponent<PhysicalProperties>().Brittleness = 0f;
          this.GetComponent<PhysicalProperties>().BulletSpeedAbsorptionPower = 50f;
          break;
        case 2:
          this.GetComponent<PhysicalProperties>().Softness = 0f;
          this.GetComponent<PhysicalProperties>().Brittleness = 0f;
          this.GetComponent<PhysicalProperties>().BulletSpeedAbsorptionPower = 100f;
           if (!GetComponent<BoxCollider2D>())
                    {
                        gameObject.AddComponent<BoxCollider2D>();
                    }
                    GetComponent<BoxCollider2D>().size = new Vector3(GetComponent<BoxCollider2D>().size.x * 10, GetComponent<BoxCollider2D>().size.y * 10);
                    break;
        case 3:
                    GetComponent<PhysicalProperties>().Softness = 0f;
                    GetComponent<PhysicalProperties>().Brittleness = 0f;
                    GetComponent<PhysicalProperties>().BulletSpeedAbsorptionPower = 200f;
                    if (!GetComponent<BoxCollider2D>())
                    {
                        gameObject.AddComponent<BoxCollider2D>();
                    }
                    GetComponent<BoxCollider2D>().size = new Vector3(GetComponent<BoxCollider2D>().size.x * 10, GetComponent<BoxCollider2D>().size.y * 10);
                    break;
      }
    }

    public void SpawnOtherParts()
    {
      GameObject instance1 = Object.Instantiate<GameObject>(ModAPI.FindSpawnable(this.otherName).Prefab, this.transform.position, this.transform.rotation);
      instance1.name = ModAPI.FindSpawnable(this.otherName).name;
      instance1.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite(this.otherSprite, 1f, true);
      if (this.GetComponent<PhysicalBehaviour>().IsWeightless)
        instance1.GetComponent<PhysicalBehaviour>().MakeWeightless();
      ArmorBehaviour armorBehaviour1 = instance1.AddComponent<ArmorBehaviour>();
      armorBehaviour1.stabResistance = this.otherResist;
      armorBehaviour1.armorPiece = this.otherPiece;
      armorBehaviour1.armorTier = this.otherTier;
      instance1.FixColliders();
      if (!this.threepieces)
        return;
      GameObject instance2 = Object.Instantiate<GameObject>(ModAPI.FindSpawnable(this.otherName).Prefab, instance1.transform.position, this.transform.rotation);
      instance2.name = ModAPI.FindSpawnable(this.otherName).name;
      instance2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite(this.thirdsprite, 1f, true);
      if (this.GetComponent<PhysicalBehaviour>().IsWeightless)
        instance2.GetComponent<PhysicalBehaviour>().MakeWeightless();
      ArmorBehaviour armorBehaviour2 = instance2.AddComponent<ArmorBehaviour>();
      armorBehaviour2.stabResistance = this.otherResist;
      armorBehaviour2.armorPiece = this.thirdpart;
      armorBehaviour2.armorTier = this.otherTier;
      instance2.FixColliders();
    }

    private void Update()
    {
      if (!this.equipped || !(bool) (Object) this.GetComponent<FixedJoint2D>().connectedBody.gameObject.GetComponent<GripBehaviour>() || !(bool) (Object) this.GetComponent<FixedJoint2D>().connectedBody.gameObject.GetComponent<GripBehaviour>().CurrentlyHolding)
        return;
      this.Nocollide(this.GetComponent<FixedJoint2D>().connectedBody.gameObject.GetComponent<GripBehaviour>().CurrentlyHolding.gameObject);
    }

    private void OnCollisionEnter2D(Collision2D collision)
    {
      LimbBehaviour component1 = collision.gameObject.GetComponent<LimbBehaviour>();
      ArmorBehaviour component2 = collision.gameObject.GetComponent<ArmorBehaviour>();
      if ((bool) (Object) component2)
        this.Nocollide(component2.gameObject);
      if ((bool) (Object) component1)
      {
        this.Nocollide(component1.gameObject);
        Debug.Log((object) component1.gameObject.ToString());
        Debug.Log((object) this.armorPiece);
        if (!this.equipped && component1.gameObject.ToString() == this.armorPiece + " (UnityEngine.GameObject)")
        {
          Debug.Log((object) "attach");
          this.Attach(component1);
        }
      }
      if (this.equipped && (double) collision.gameObject.GetComponent<Rigidbody2D>().velocity.x < (double) this.stabResistance && !(bool) (Object) component1)
      {
        this.transform.parent = component1.transform;
        this.GetComponent<Rigidbody2D>().isKinematic = true;
        this.GetComponent<FixedJoint2D>().enabled = false;
      }
      else
      {
        if (!this.equipped)
          return;
        this.transform.parent = (Transform) null;
        this.GetComponent<Rigidbody2D>().isKinematic = false;
        this.GetComponent<FixedJoint2D>().enabled = true;
      }
    }

    private void OnCollisionExit2D(Collision2D collision)
    {
      if (!this.GetComponent<Rigidbody2D>().isKinematic)
        return;
      this.transform.parent = (Transform) null;
      this.GetComponent<Rigidbody2D>().isKinematic = false;
      this.GetComponent<FixedJoint2D>().enabled = true;
    }

    public void Nocollide(GameObject col)
    {
      NoCollide noCollide = this.gameObject.AddComponent<NoCollide>();
      noCollide.NoCollideSetA = this.GetComponents<Collider2D>();
      noCollide.NoCollideSetB = col.GetComponents<Collider2D>();
    }

    public void Attach(LimbBehaviour limb)
    {
      this.GetComponent<Rigidbody2D>().angularVelocity = 0.0f;
      SpriteRenderer component = this.GetComponent<SpriteRenderer>();
      component.sortingOrder = limb.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
      component.sortingLayerName = limb.gameObject.GetComponent<SpriteRenderer>().sortingLayerName;
      this.equipped = true;
      this.GetComponent<Rigidbody2D>().isKinematic = true;
      this.transform.parent = limb.transform;
      this.transform.localEulerAngles = new Vector3(0.0f, 0.0f, 0.0f);
      this.transform.localPosition = new Vector3(0.0f, 0.0f, 0.0f);
      this.transform.localScale = new Vector3(1f, 1f, 1f);
      this.transform.parent = (Transform) null;
      FixedJoint2D fixedJoint2D = this.gameObject.AddComponent<FixedJoint2D>();
      fixedJoint2D.dampingRatio = 1f;
      fixedJoint2D.frequency = 0.0f;
      fixedJoint2D.connectedBody = limb.GetComponent<Rigidbody2D>();
      this.GetComponent<Rigidbody2D>().isKinematic = false;
      this.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
      this.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
    }
  }