﻿using UnityEngine;

namespace Mod
{
public class WebWireTool : DistanceWireTool
{
  private void Awake()
  {
    this.WireMaterial = Resources.Load<Material>("Materials/Wire");
    this.WireColor = new Color(1f, 1f, 1f);
  }

  protected override void OnJointCreate(DistanceJoint2D joint)
  {
    CableBehaviour cableBehaviour = joint.gameObject.AddComponent<CableBehaviour>();
    UndoControllerBehaviour.RegisterAction((IUndoableAction) new ObjectCreationAction((Object) cableBehaviour, "cable"));
    cableBehaviour.WireColor = this.WireColor;
    cableBehaviour.WireMaterial = this.WireMaterial;
    cableBehaviour.WireWidth = this.WireWidth;
    cableBehaviour.typedJoint = joint;
}
  }
}