﻿using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
            CategoryBuilder.Create("NWH", "No Way Home mod category", ModAPI.LoadSprite("CategoryThumb.png"));
            ModAPI.RegisterTool<WebWireTool>("Web", "Just a web", ModAPI.LoadSprite("web.png"), "Wire");

                ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Charmed Web-Shooter",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("NWH"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/ws.png"),
        AfterSpawn = (Instance) =>

                {
                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/nwh/ws", 1f);
                    Instance.FixColliders();


                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/nwh/ws.png", 1f);
                    ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                    armor.stabResistance = 40f;
                    armor.armorPiece = "LowerArmFront";
                    armor.armorTier = 13;

                    Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
                    Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                    Instance.FixColliders();
                }
    }
);


            ModAPI.Register(
        new Modification()
        {
            OriginalItem = ModAPI.FindSpawnable("Sticky Grenade"),
            NameOverride = "Green Goblin Grenade",
            DescriptionOverride = "",
            CategoryOverride = ModAPI.FindCategory("NWH"),
            NameToOrderByOverride = "1",
            ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/gr.png"),
            AfterSpawn = (Instance) =>
            {
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/nwh/gr.png");
                foreach (var c in Instance.GetComponents<Collider2D>())
                {
                    GameObject.Destroy(c);
                }

                Instance.FixColliders();
            }

        }
    );

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Tentacle",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("NWH"),
        NameToOrderByOverride = "1",
        ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/t.png"),
        AfterSpawn = (Instance) =>
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/nwh/t.png");
            foreach (var c in Instance.GetComponents<Collider2D>())
            {
                GameObject.Destroy(c);
            }

            Instance.FixColliders();
        }

    }
);

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Dampening Box"),
        NameOverride = "Green Goblin Glider",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("NWH"),
        NameToOrderByOverride = "1",
        ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/gl.png"),
        AfterSpawn = (Instance) =>
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/nwh/gl.png");
            foreach (var c in Instance.GetComponents<Collider2D>())
            {
                GameObject.Destroy(c);
            }

            Instance.FixColliders();
        }

    }
);

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stormbaan"),
        NameOverride = "Electrical charge",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("NWH"),
        NameToOrderByOverride = "1",
        ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/ec.png"),
        AfterSpawn = (Instance) =>
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/nwh/el.png");
            foreach (var c in Instance.GetComponents<Collider2D>())
            {
                GameObject.Destroy(c);
            }

            Instance.FixColliders();

            var knife = Instance.AddComponent<BoxCollider2D>();
            knife.size = new Vector2(0.1f, 0.57f);
            var phys = Instance.GetComponent<PhysicalBehaviour>().Properties;

        }

    }
);


            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Rod"),
    NameOverride = "Cube",
    DescriptionOverride = "",
    CategoryOverride = ModAPI.FindCategory("NWH"),
    NameToOrderByOverride = "1",
    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/cube.png"),
    AfterSpawn = (Instance) =>
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/nwh/cube.png");
            foreach (var c in Instance.GetComponents<Collider2D>())
            {
                GameObject.Destroy(c);
            }

            Instance.FixColliders();

        }

}
);

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Magic Charge",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("NWH"),
        NameToOrderByOverride = "1",
        ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/sh.png"),
        AfterSpawn = (Instance) =>
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/nwh/sh.png");
            foreach (var c in Instance.GetComponents<Collider2D>())
            {
                GameObject.Destroy(c);
            }

            Instance.FixColliders();
        }

    }
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Knife"),
    NameOverride = "Tentacle blade",
    DescriptionOverride = "",
    CategoryOverride = ModAPI.FindCategory("NWH"),
    NameToOrderByOverride = "1",
    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/bl.png"),
    AfterSpawn = (Instance) =>
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/nwh/blade.png");
            foreach (var c in Instance.GetComponents<Collider2D>())
            {
                GameObject.Destroy(c);
            }

            Instance.FixColliders();


        }
}

);


            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Spider-Man (Tom Holland)",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("NWH"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/is.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/is/is.png");
            var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
            var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
        }
    }
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Spider-Man Damaged (Tom Holland) ",
    DescriptionOverride = "",
    CategoryOverride = ModAPI.FindCategory("NWH"),
    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/isd.png"),
    AfterSpawn = (Instance) =>
    {
        var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/is/isd.png");
        var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
        var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
    }
}
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Peter Parker (Tom Holland)",
    DescriptionOverride = "",
    CategoryOverride = ModAPI.FindCategory("NWH"),
    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/th.png"),
    AfterSpawn = (Instance) =>
    {
        var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/is/pp.png");
        var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
        var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
    }
}
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Peter Parker (Tobey Maguire)",
    DescriptionOverride = "",
    CategoryOverride = ModAPI.FindCategory("NWH"),
    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/tm.png"),
    AfterSpawn = (Instance) =>
    {
        var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/sm/pp.png");
        var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
        var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Spider-Man Unmasked (Tobey Maguire)",
    DescriptionOverride = "",
    CategoryOverride = ModAPI.FindCategory("NWH"),
    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/tm.png"),
    AfterSpawn = (Instance) =>
    {
        var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/sm/smu.png");
        var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
        var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
    }
}
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Spider-Man Unmasked (Andrew Garfield)",
    DescriptionOverride = "",
    CategoryOverride = ModAPI.FindCategory("NWH"),
    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/ag.png"),
    AfterSpawn = (Instance) =>
    {
        var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/tasm/tasmu.png");
        var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
        var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);


        var low = Instance.transform.Find("Head");
        GameObject wings = new GameObject();
        wings.transform.parent = low;
        wings.transform.localPosition = new Vector4(0f, 0f);
        wings.transform.localScale = new Vector4(1f, 1f);

        var wingsprite = wings.AddComponent<SpriteRenderer>();

        wingsprite.sprite = ModAPI.LoadSprite("Sprites/nwh/Characters/tasm/pphair.png");
        wingsprite.material = ModAPI.FindMaterial("Sprites-Default");
        wingsprite.sortingLayerName = "Top";
    }
}
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Peter Parker (Andrew Garfield)",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("NWH"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/ag.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/tasm/pp.png");
            var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
            var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

            var low = Instance.transform.Find("Head");
            GameObject wings = new GameObject();
            wings.transform.parent = low;
            wings.transform.localPosition = new Vector4(0f, 0f);
            wings.transform.localScale = new Vector4(1f, 1f);

            var wingsprite = wings.AddComponent<SpriteRenderer>();

            wingsprite.sprite = ModAPI.LoadSprite("Sprites/nwh/Characters/tasm/pphair.png");
            wingsprite.material = ModAPI.FindMaterial("Sprites-Default");
            wingsprite.sortingLayerName = "Top";
        }
    }
);

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Ned Leeds",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("NWH"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/n.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/ned/ned.png");
            var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
            var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
        }
    }
);
            ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Android"),
      NameOverride = "Sandman (Sand form)",
      NameToOrderByOverride = "!",
      DescriptionOverride = "",
      CategoryOverride = ModAPI.FindCategory("NWH"),
      ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/full.png"),
      AfterSpawn = (Instance) =>
      {
          var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/sand/full.png");
          var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/full.png");
          var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
          Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

      }
  }
);
                                    ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Human"),
      NameOverride = "Sandman (Sand form 2)",
      NameToOrderByOverride = "!",
      DescriptionOverride = "That version doesn't fry in water",
      CategoryOverride = ModAPI.FindCategory("NWH"),
      ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/full.png"),
      AfterSpawn = (Instance) =>
      {
          var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/sand/full.png");
          var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/full.png");
          var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
          Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

      }
  }
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Sandman (Human form)",
    NameToOrderByOverride = "!",
    DescriptionOverride = "",
    CategoryOverride = ModAPI.FindCategory("NWH"),
    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/sand.png"),
    AfterSpawn = (Instance) =>
    {
        var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/sand/sand.png");
        var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
        var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

    }
}
);


            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Android"),
                  NameOverride = "Lizard",
                  NameToOrderByOverride = "!",
                  DescriptionOverride = "",
                  CategoryOverride = ModAPI.FindCategory("NWH"),
                  ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/l.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/l/l.png");
                      var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
                      var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
                      Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                      ;
                      var low = Instance.transform.Find("Body").Find("LowerBody");

                      GameObject wings = new GameObject();
                      wings.transform.parent = low;
                      wings.transform.localPosition = new Vector4(0f, 0f);
                      wings.transform.localScale = new Vector4(1f, 1f);

                      var wingsprite = wings.AddComponent<SpriteRenderer>();

                      wingsprite.sprite = ModAPI.LoadSprite("Sprites/nwh/Characters/l/tail.png");
                      wingsprite.material = ModAPI.FindMaterial("Sprites-Default");
                      wingsprite.sortingLayerName = "Mid";

                  }
              }
          );

                        ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Human"),
      NameOverride = "Lizard (not android)",
      NameToOrderByOverride = "!",
      DescriptionOverride = "That version doesn't fry in water",
      CategoryOverride = ModAPI.FindCategory("NWH"),
      ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/l.png"),
      AfterSpawn = (Instance) =>
      {
          var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/l/l.png");
          var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
          var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
          Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
          ;
          var low = Instance.transform.Find("Body").Find("LowerBody");

          GameObject wings = new GameObject();
          wings.transform.parent = low;
          wings.transform.localPosition = new Vector4(0f, 0f);
          wings.transform.localScale = new Vector4(1f, 1f);

          var wingsprite = wings.AddComponent<SpriteRenderer>();

          wingsprite.sprite = ModAPI.LoadSprite("Sprites/nwh/Characters/l/tail.png");
          wingsprite.material = ModAPI.FindMaterial("Sprites-Default");
          wingsprite.sortingLayerName = "Mid";

      }
  }
);

            ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Human"),
      NameOverride = "Doctor Strange",
      NameToOrderByOverride = "!",
      DescriptionOverride = "",
      CategoryOverride = ModAPI.FindCategory("NWH"),
      ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/ds.png"),
      AfterSpawn = (Instance) =>
      {
          var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/ds/ds.png");
          var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
          var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
          Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
          ;
          var up = Instance.transform.Find("Body").Find("UpperBody");

          GameObject wings = new GameObject();
          wings.transform.parent = up;
          wings.transform.localPosition = new Vector4(0f, 0f);
          wings.transform.localScale = new Vector4(1f, 1f);

          var wingsprite = wings.AddComponent<SpriteRenderer>();

          wingsprite.sprite = ModAPI.LoadSprite("Sprites/nwh/Characters/ds/coat.png");
          wingsprite.material = ModAPI.FindMaterial("Sprites-Default");
          wingsprite.sortingLayerName = "Top";

      }
  }
);

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "J. Jonah Jameson",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("NWH"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/j.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/j/j.png");
                        var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
                        var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                    }
                }
            );

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "J. Jonah Jameson (In coat)",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("NWH"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/jhat.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/j/jhat.png");
            var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
            var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

            var head = Instance.transform.GetChild(5);
            var childObject = new GameObject("hat");
            childObject.transform.SetParent(head);
            childObject.transform.localPosition = new Vector3(0, 0f);
            childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
            childObject.transform.localScale = new Vector3(1f, 1f);
            var childSprite = childObject.AddComponent<SpriteRenderer>();
            childSprite.sprite = ModAPI.LoadSprite("Sprites/nwh/Characters/j/hat.png");
            childSprite.sortingLayerName = "Top";
        }
    }
);

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Spider-Man (Andrew Garfield)",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("NWH"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/tasm.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/tasm/tasm.png");
            var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
            var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

        }
    }
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "MrTul3cnhik",
    DescriptionOverride = "It's me!",
    CategoryOverride = ModAPI.FindCategory("Misc."),
    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/me.png"),
    AfterSpawn = (Instance) =>
    {
        var skin = ModAPI.LoadTexture("whatadogdoin.png");
        var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
        var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);


    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Doc Ock",
    DescriptionOverride = "",
    CategoryOverride = ModAPI.FindCategory("NWH"),
    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/do.png"),
    AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/do/do.png");
            var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
            var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

        }
}
);


            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Spider-Man (Tobey Maguire)",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("NWH"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/sm.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/sm/sm.png");
            var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
            var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

        }
    }
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Spider-Man (Black and gold suit)",
    NameToOrderByOverride = "!",
    DescriptionOverride = "",
    CategoryOverride = ModAPI.FindCategory("NWH"),
    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/bg.png"),
    AfterSpawn = (Instance) =>
    {
        var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/is/bg.png");
        var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
        var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

        var head = Instance.transform.GetChild(0);
        var childObject = new GameObject("helmet");
        childObject.transform.SetParent(head);
        childObject.transform.localPosition = new Vector3(0, 0f);
        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
        childObject.transform.localScale = new Vector3(1f, 1f);
        var childSprite = childObject.AddComponent<SpriteRenderer>();
        childSprite.sprite = ModAPI.LoadSprite("Sprites/nwh/helmet.png");
        childSprite.sortingLayerName = "Top";
    }
}
);

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Green Goblin",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("NWH"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/gg.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/gg/gg.png");
            var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshlayer.png");
            var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

            var head = Instance.transform.GetChild(5);
            var childObject = new GameObject("caseyhair");
            childObject.transform.SetParent(head);
            childObject.transform.localPosition = new Vector3(0, 0f);
            childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
            childObject.transform.localScale = new Vector3(1f, 1f);
            var childSprite = childObject.AddComponent<SpriteRenderer>();
            childSprite.sprite = ModAPI.LoadSprite("Sprites/nwh/Characters/gg/hood.png");
            childSprite.sortingLayerName = "Top";
        }
    }
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Green Goblin (Damaged)",
    NameToOrderByOverride = "!",
    DescriptionOverride = "",
    CategoryOverride = ModAPI.FindCategory("NWH"),
    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/ggd.png"),
    AfterSpawn = (Instance) =>
    {
        var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/gg/ggu.png");
        var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshlayer.png");
        var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
    }
}
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Electro",
    NameToOrderByOverride = "!",
    DescriptionOverride = "",
    CategoryOverride = ModAPI.FindCategory("NWH"),
    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/el.png"),
    AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/el/el.png");
            var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
            var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
            var upper = Instance.transform.Find("Body").Find("UpperBody");

            GameObject reactor = new GameObject();
            reactor.transform.parent = upper;
            reactor.transform.localPosition = new Vector4(0f, 0f);
            reactor.transform.localScale = new Vector4(1f, 1f);

            var reactorprite = reactor.AddComponent<SpriteRenderer>();

            reactorprite.sprite = ModAPI.LoadSprite("Sprites/nwh/Characters/el/reactor.png");
            reactorprite.material = ModAPI.FindMaterial("VeryBright");
            reactorprite.color = new Color(1f, 1f, 1f, 0.04f);
            reactorprite.sortingLayerName = "Top";

            var eye = Instance.transform.Find("Head");

            GameObject mask = new GameObject();
            mask.transform.parent = eye;
            mask.transform.localPosition = new Vector4(0f, 0f);
            mask.transform.localScale = new Vector4(1f, 1f);

            var maskprite = mask.AddComponent<SpriteRenderer>();

            maskprite.sprite = ModAPI.LoadSprite("Sprites/nwh/Characters/el/mask.png");
            maskprite.material = ModAPI.FindMaterial("VeryBright");
            maskprite.color = new Color(1f, 1f, 1f, 0.04f);
            maskprite.sortingLayerName = "Top";


        }
}
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Maxwell Dillon",
    NameToOrderByOverride = "!",
    DescriptionOverride = "",
    CategoryOverride = ModAPI.FindCategory("NWH"),
    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/md.png"),
    AfterSpawn = (Instance) =>
            {
                var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/el/el.png");
                var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
                var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
                Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

            }
}
);

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Michelle Jones",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("NWH"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/mj.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/mj/mj.png");
            var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
            var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

            var head = Instance.transform.GetChild(5);
            var childObject = new GameObject("mjhair");
            childObject.transform.SetParent(head);
            childObject.transform.localPosition = new Vector3(0, 0f);
            childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
            childObject.transform.localScale = new Vector3(1f, 1f);
            var childSprite = childObject.AddComponent<SpriteRenderer>();
            childSprite.sprite = ModAPI.LoadSprite("Sprites/nwh/Characters/mj/mjhair.png");
            childSprite.sortingLayerName = "Top";

        }
    }
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "May Parker",
    NameToOrderByOverride = "!",
    DescriptionOverride = "",
    CategoryOverride = ModAPI.FindCategory("NWH"),
    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/nwh/m.png"),
    AfterSpawn = (Instance) =>
    {
        var skin = ModAPI.LoadTexture("Sprites/nwh/Characters/m/m.png");
        var flesh = ModAPI.LoadTexture("Sprites/nwh/Characters/fleshLayer.png");
        var bone = ModAPI.LoadTexture("Sprites/nwh/Characters/boneLayer.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

        var head = Instance.transform.GetChild(5);
        var childObject = new GameObject("mhair");
        childObject.transform.SetParent(head);
        childObject.transform.localPosition = new Vector3(0, 0f);
        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
        childObject.transform.localScale = new Vector3(1f, 1f);
        var childSprite = childObject.AddComponent<SpriteRenderer>();
        childSprite.sprite = ModAPI.LoadSprite("Sprites/nwh/Characters/m/mhair.png");
        childSprite.sortingLayerName = "Top";

    }
}
);


            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Web Shooter Back",
                    NameToOrderByOverride = "",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("NWH"),
                    ThumbnailOverride = ModAPI.LoadSprite("webthumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/NWH/web.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 5f;
                        armor.armorPiece = "LowerArm";
                        armor.armorTier = 3;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;

                        Instance.AddComponent<EMP4>();


                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Web Shooter Front",
                    NameToOrderByOverride = "",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("NWH"),
                    ThumbnailOverride = ModAPI.LoadSprite("webthumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/NWH/web.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 5f;
                        armor.armorPiece = "LowerArmFront";
                        armor.armorTier = 3;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;

                        Instance.AddComponent<EMP4>();


                        Instance.FixColliders();
                    }
                }
            );
        }


        public class ArmorBehaviour : MonoBehaviour
        {
            private bool equipped;
            [SerializeField]
            public ArmorProperties prop;
            public string armorPiece;
            public int armorTier;
            public float stabResistance;
            private bool blockingStab;

            public Vector3 offset;
            public Vector3 scaleOffset = new Vector3(1, 1, 1);

            public ArmorBehaviour[] SetPieces = new ArmorBehaviour[0];
            public int pieceCount;
            public bool headCovering;

            [SerializeField]
            public LimbBehaviour attachedLimb;

            [SerializeField]
            public bool spawn = true;
            [SerializeField]
            public Color color = new Color(1, 1, 1);
            [SerializeField]
            public bool decorative;
            [SerializeField]
            public bool grayScale;

            void Start()
            {
                if (grayScale)
                    GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite(prop.graySprite); //Checks if Grayscale is on.
                ContextMenu();
                SetProperties();
                GetComponent<PhysicalBehaviour>().RefreshOutline();
                if (attachedLimb)
                {
                    Attach(attachedLimb);
                }
                ApplyColor(color);
                GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[0];
            }
            public void ApplyColor(Color color)
            {
                GetComponent<SpriteRenderer>().color = color;
            }
            public void ApplyTier()
            {
                Debug.Log("Tier of " + gameObject.name + " applied.");
                PhysicalBehaviour phys = GetComponent<PhysicalBehaviour>();

                PhysicalProperties prop = ScriptableObject.CreateInstance<PhysicalProperties>();
                PhysicalProperties metal = ModAPI.FindPhysicalProperties("Metal");
                PhysicalProperties bowling = ModAPI.FindPhysicalProperties("Bowling pin");
                switch (armorTier)
                {
                    case 0:
                        prop.Softness = 1;
                        prop.Brittleness = 1;
                        break;
                    case 1:
                        prop.SoftImpact = bowling.SoftImpact;
                        prop.HardImpact = bowling.HardImpact;
                        prop.PhysicMaterial = bowling.PhysicMaterial;
                        prop.SharpForceThresholdMultiplier = bowling.SharpForceThresholdMultiplier;
                        prop.ImpactIntensityMutliplier = bowling.ImpactIntensityMutliplier;
                        prop.HitVolumeMultiplier = bowling.HitVolumeMultiplier;

                        prop.Softness = 0f;
                        prop.Brittleness = 0f;
                        prop.BulletSpeedAbsorptionPower = 0.5f;
                        prop.ShotImpact = bowling.ShotImpact;
                        phys.Properties = prop;
                        break;
                    case 2:
                        prop.SoftImpact = bowling.SoftImpact;
                        prop.HardImpact = bowling.HardImpact;
                        prop.PhysicMaterial = bowling.PhysicMaterial;
                        prop.SharpForceThresholdMultiplier = bowling.SharpForceThresholdMultiplier;
                        prop.ImpactIntensityMutliplier = bowling.ImpactIntensityMutliplier;
                        prop.HitVolumeMultiplier = bowling.HitVolumeMultiplier;

                        prop.Softness = 0f;
                        prop.Brittleness = 0f;
                        prop.BulletSpeedAbsorptionPower = 2f;
                        prop.ShotImpact = bowling.ShotImpact;
                        phys.Properties = prop;
                        break;
                    case 3:

                        prop.SoftImpact = metal.SoftImpact;
                        prop.HardImpact = metal.HardImpact;
                        prop.PhysicMaterial = metal.PhysicMaterial;
                        prop.SharpForceThresholdMultiplier = metal.SharpForceThresholdMultiplier;
                        prop.ImpactIntensityMutliplier = metal.ImpactIntensityMutliplier;
                        prop.HitVolumeMultiplier = metal.HitVolumeMultiplier;

                        prop.Softness = 0f;
                        prop.Brittleness = 0f;
                        prop.BulletSpeedAbsorptionPower = 3f;
                        prop.ShotImpact = metal.ShotImpact;
                        phys.Properties = prop;
                        break;
                    case 4:

                        prop.Softness = 0f;
                        prop.Brittleness = 0f;
                        prop.BulletSpeedAbsorptionPower = 4f;
                        prop.SoftImpact = bowling.SoftImpact;
                        prop.HardImpact = bowling.HardImpact;
                        prop.PhysicMaterial = bowling.PhysicMaterial;
                        prop.SharpForceThresholdMultiplier = bowling.SharpForceThresholdMultiplier;
                        prop.ImpactIntensityMutliplier = bowling.ImpactIntensityMutliplier;
                        prop.HitVolumeMultiplier = bowling.HitVolumeMultiplier;
                        prop.ShotImpact = bowling.ShotImpact;

                        phys.Properties = prop;
                        break;
                    default:
                        ModAPI.Notify("Armor tier " + armorTier.ToString() + " does not exist.");
                        break;
                }
            }
            public void SetProperties()
            {
                GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite(prop.sprite);
                armorPiece = prop.armorPiece;
                armorTier = prop.armorTier;
                offset = prop.offset;

                scaleOffset += prop.scaleOffset;

                if (GetComponent<Optout>())
                    Destroy(GetComponent<Optout>());

                if (prop.mass != 0)
                {
                    GetComponent<PhysicalBehaviour>().InitialMass = prop.mass;
                    GetComponent<PhysicalBehaviour>().TrueInitialMass = prop.mass;
                    GetComponent<PhysicalBehaviour>().rigidbody.mass = prop.mass;
                }
                ApplyTier();
                gameObject.FixColliders();
            }
            public void CloneSelf()
            {
                GameObject other = ModAPI.CreatePhysicalObject(gameObject.name, ModAPI.LoadSprite(prop.sprite));

                other.AddComponent<SerialiseInstructions>().OriginalSpawnableAsset = ModAPI.FindSpawnable("Rod");
                other.transform.position = transform.position;

                PhysicalBehaviour phys = GetComponent<PhysicalBehaviour>();

                other.GetComponent<PhysicalBehaviour>().InitialMass = phys.InitialMass;
                other.GetComponent<PhysicalBehaviour>().TrueInitialMass = phys.TrueInitialMass;
                other.GetComponent<PhysicalBehaviour>().InitialGravityScale = phys.InitialGravityScale;
                other.GetComponent<PhysicalBehaviour>().rigidbody.mass = phys.rigidbody.mass;

                ArmorBehaviour otherArmor = other.AddComponent<ArmorBehaviour>();
                otherArmor.prop = prop;
                otherArmor.prop.armorPiece = prop.armorPiece + "Front";

                otherArmor.offset = offset;
                otherArmor.scaleOffset = scaleOffset;
                otherArmor.SetProperties();
            }
            void ContextMenu()
            {

                GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("detachbut", "Detach armor", "Detach the armor from whatever it is equipped on.", new UnityAction[1]
                {
                (UnityAction) (() =>
                {
                    if (attachedLimb)
                        Detach(attachedLimb);
                    else
                        ModAPI.Notify("The armor is not attached to anything");
                })
                }));
                GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("sortplusbut", "Bring forward", "Bring the sprite of the armor forward.", new UnityAction[1]
                {
                (UnityAction) (() => GetComponent<SpriteRenderer>().sortingOrder++)
                }));
                GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("sortminusbut", "Bring back", "Bring the sprite of the armor back.", new UnityAction[1]
                {
                (UnityAction) (() => GetComponent<SpriteRenderer>().sortingOrder--)
                }));
            }
            public void SpawnOtherParts(ArmorProperties[] properties)
            {
                for (int I = 0; I <= SetPieces.Length - 1; I++)
                {
                    GameObject other = ModAPI.CreatePhysicalObject(gameObject.name, GetComponent<SpriteRenderer>().sprite);
                    other.transform.position = transform.position;
                    other.AddComponent<SerialiseInstructions>().OriginalSpawnableAsset = ModAPI.FindSpawnable("Rod");

                    PhysicalBehaviour phys = GetComponent<PhysicalBehaviour>();

                    other.GetComponent<PhysicalBehaviour>().InitialMass = phys.InitialMass;
                    other.GetComponent<PhysicalBehaviour>().TrueInitialMass = phys.TrueInitialMass;
                    other.GetComponent<PhysicalBehaviour>().InitialGravityScale = phys.InitialGravityScale;
                    other.GetComponent<PhysicalBehaviour>().rigidbody.mass = phys.rigidbody.mass;

                    ArmorBehaviour otherArmor = other.AddComponent<ArmorBehaviour>();
                    otherArmor.spawn = false;

                    otherArmor.prop = prop;

                    otherArmor.offset = offset;
                    otherArmor.scaleOffset = scaleOffset;
                    SetPieces[I] = otherArmor;
                }
                SetPartProperties(properties);
            }
            public void SetPartProperties(ArmorProperties[] properties)
            {
                spawn = false;
                int I = 0;
                foreach (ArmorBehaviour armor in SetPieces)
                {
                    armor.prop = properties[I];
                    I++;
                    armor.SetProperties();
                    if (armor.prop.clone)
                        armor.CloneSelf();
                }
            }
            void Update()
            {
                if (equipped && GetComponent<FixedJoint2D>().connectedBody.gameObject.GetComponent<GripBehaviour>() && GetComponent<FixedJoint2D>().connectedBody.gameObject.GetComponent<GripBehaviour>().CurrentlyHolding)
                {
                    GripBehaviour grip = GetComponent<FixedJoint2D>().connectedBody.gameObject.GetComponent<GripBehaviour>();
                    Nocollide(grip.CurrentlyHolding.gameObject);
                }
            }
            private void OnCollisionEnter2D(Collision2D collision)
            {
                if (!decorative)
                {
                    LimbBehaviour limb = collision.gameObject.GetComponent<LimbBehaviour>();
                    ArmorBehaviour arm = collision.gameObject.GetComponent<ArmorBehaviour>();
                    if (arm)
                    {
                        Nocollide(arm.gameObject);
                    }
                    if (limb)
                    {
                        Nocollide(limb.gameObject);

                        if (!equipped && limb.gameObject.name == armorPiece)
                        {
                            Attach(limb);
                        }
                    }
                    Rigidbody2D rb = collision.gameObject.GetComponent<Rigidbody2D>();

                }
            }
            public void Nocollide(GameObject col)
            {
                NoCollide noCol = gameObject.AddComponent<NoCollide>();
                noCol.NoCollideSetA = GetComponents<Collider2D>();
                noCol.NoCollideSetB = col.GetComponents<Collider2D>();
            }
            public void Attach(LimbBehaviour limb)
            {
                GetComponent<Rigidbody2D>().angularVelocity = 0;
                SpriteRenderer sr = GetComponent<SpriteRenderer>();
                sr.sortingOrder = limb.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                sr.sortingLayerName = limb.gameObject.GetComponent<SpriteRenderer>().sortingLayerName;
                equipped = true;
                GetComponent<Rigidbody2D>().isKinematic = true;
                transform.parent = limb.transform;
                transform.localEulerAngles = new Vector3(0, 0, 0);
                transform.localPosition = offset;
                transform.localScale = scaleOffset;
                transform.parent = null;
                FixedJoint2D joint = gameObject.AddComponent<FixedJoint2D>();
                joint.dampingRatio = 1;
                joint.frequency = 0;
                joint.connectedBody = limb.GetComponent<Rigidbody2D>();
                GetComponent<Rigidbody2D>().isKinematic = false;
                attachedLimb = limb;
            }
            public void Detach(LimbBehaviour limb)
            {
                GetComponent<Rigidbody2D>().angularVelocity = 0;
                equipped = false;
                foreach (FixedJoint2D joint in GetComponents<FixedJoint2D>())
                {
                    if (joint.connectedBody = limb.gameObject.GetComponent<Rigidbody2D>())
                        Destroy(joint);
                }
                attachedLimb = null;
            }

        }

        public struct ArmorProperties
        {
            public string sprite;
            public string armorPiece;
            public int armorTier;
            public float mass;
            public bool clone;
            public Vector3 offset;
            public Vector3 scaleOffset;
            public string graySprite;
        };


    }

}
